<?php
/*
Plugin Name: Multi Editor Posts Control
Plugin URI: http://mondonotizie.info/MEPC
Description: This plugin allow in a multi auhtor blog, to lock posts by editor permission level. Good for lock Editors capability in order to editing the posts previously published by another editor user. 
Version: 1.5
Author: Marzaro Gianluca
License: GPL2


    Copyright 2010  Gianluca Marzaro  (email : gianluca@marzaro.it)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License, version 2, as 
    published by the Free Software Foundation.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/


function lockpostby_editor_author_level( $capauser, $capask, $param){

		global $current_user, $post;
       	get_currentuserinfo();

		$user = $current_user->display_name; //get user name of currently logged in user.
		$user_id = $current_user->ID; //get user ID  of currently logged in user.
		$user_level = $current_user->user_level; // get the level_permission of the user.
		
		$author = get_the_author(); //get author user_name of the parse posts.
		$last_editor = get_the_modified_author(); //get the last user_name of the post moderator.
		
		$status = get_post_status();
		$other_editor = get_post_meta($post->ID, '_sp_authors', true);
		
		if (strpos($other_editor, $user_id) === false) { $allow_edit = false; } else { $allow_edit = true; }
		
		
   /* If it's admin don't do anything */
   if ( empty( $capauser['administrator'] ) || !$capauser['administrator'] ) {
      /* Do something only if it's for "edit_post" or "delete_post"*/  
      if ( ( $param[0] == "edit_post") || ( $param[0] == "delete_post" ) ) {
         
		 
		 /* Test the post status, currently logged in user level, and check if the author of the post match with the user_editor */
		if ($status == 'draft' || $status == 'future') {
				if ( $user == $author || $user == $last_editor || $allow_edit) {
		
            foreach( (array) $capask as $capasuppr) {
               if ( array_key_exists($capasuppr, $capauser) ) { 
			   $capauser[$capasuppr]=1; }
													}
										}
										elseif ( $user <> $author) {
										foreach( (array) $capask as $capasuppr) {
               if ( array_key_exists($capasuppr, $capauser) ) { 
			   $capauser[$capasuppr]=0; }
													}
										}

			return $capauser;
		}
		

		if ($status == 'pending' || $allow_edit) {
		
            foreach( (array) $capask as $capasuppr) {
               if ( array_key_exists($capasuppr, $capauser) ) 
			   { $capauser[$capasuppr]=1; }
													}
			return $capauser;
		}
		
		
if ($status == 'publish') {
			
if ( $user ==  $last_editor || $user == $author || $allow_edit) {
         
            foreach( (array) $capask as $capasuppr) {
               if ( array_key_exists($capasuppr, $capauser) ) {
                  $capauser[$capasuppr]=1;
               }
            }
         } elseif ( $user <>  $last_editor || $user <> $author) {
		 foreach( (array) $capask as $capasuppr) {
               if ( array_key_exists($capasuppr, $capauser) ) {
                  $capauser[$capasuppr]=0;
               }
            }
		 
		 }
      }
   }
      
   }
return $capauser;
}

add_filter('user_has_cap', 'lockpostby_editor_author_level', 100, 3);


?>
